#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <time.h>
#pragma option -3

void plotasm(int x, int y, unsigned char col);
void setVGApalette(unsigned char *buffer);
void setmode(int mode);
void Smooth(void);

int point(int x, int y);

union REGS regs;
struct SREGS inreg;

unsigned char Pal_Array[256][3];
int active_bank,bank,edge1[200],edge2[200];

int main(void)
{
   FILE *f=fopen("fire.pal","rb");   //Paleta de cores que vai do vermelho
				     //para amarelo para branco p/ preto.
   int x,y;

   for(int i=0;i<256;i++)
     for(int j=0;j<3;j++)
       Pal_Array[i][j]=fgetc(f);

   printf("OK... aperte qualquer tc para modo 1 e 2 para modo 2");
   int a=getch();

   setmode(0x13);
   setVGApalette(&Pal_Array[0][0]);

   if(a==50) {
   for(x=80;x<241;x++) {
     plotasm(x,49,rand()%200+55);
     plotasm(x,151,rand()%200+55);
   }
   for(y=50;y<150;y++) {
     plotasm(79,y,rand()%200+55);
     plotasm(241,y,rand()%200+55);
   }
   }

   do {
     Smooth();
     for(x=0;x<15;x++)
       plotasm((rand()%160)+80,(rand()%100)+50,rand()%200+50);
   } while(!kbhit());

   setmode(0x3);
   printf("G Soft Produes\n\n  Chuva no lago de FOGO!\n\nMande suas dvidas, comentrios ou doaes para:\ncrash_neth@lords.com\n\nGS copyright 1999\n");

   getch();
   return 0;
}

void Smooth(void)
{
  int y,x,midp,v1,v3,v2,v4;

  for(y=50;y<151;y++)
   for(x=80;x<241;x++)
   {
    if(y!=0) v1=point(x,y-1); else v1=0;
    if(x!=0) v3=point(x-1,y); else v3=0;
    if(y!=199) v2=point(x,y+1); else v2=0;
    if(x!=319) v4=point(x+1,y); else v4=0;
    midp=(v1+v2+v3+v4)/2-point(x,y);
    if(midp<0) midp=0;
    plotasm(x,y,midp);
   }
}

void setVGApalette(unsigned char *buffer)
{
  regs.x.ax=0x1012;
  segread(&inreg);
  inreg.es=inreg.ds;
  regs.x.bx=0;
  regs.x.cx=256;
  regs.x.dx=(int)&buffer[0];
  int86x(0x10,&regs,&regs,&inreg);
}

void setmode(int mode)
{
  if(mode > 0x32)
  {
    active_bank=0;
    regs.x.ax=0x6F05;
    regs.h.bl=mode;
    int86(0x10,&regs,&regs);
    outpw(0x3C4,0xEA06);
  }
  else
  {
    regs.h.ah=0;
    regs.h.al=mode;
    int86(0x10,&regs,&regs);
  }
}


void plotasm(int x, int y, unsigned char col)
{
  asm {
	push ds;
	push es;
	mov ax, 0xA000;
	mov es, ax;
	mov bx, [x];
	mov dx, [y];
	push bx;
	mov bx, dx;
	mov dh, dl;
	xor dl, dl;
	shl bx, 6;
	add dx, bx;
	pop bx;
	add bx, dx;
	mov di, bx;
	xor al, al;
	mov ah, [col];
	mov es:[di], ah;

	pop es;
	pop ds;
  }
}

int point(int x, int y)
{
  unsigned char col;
  asm {
	push ds;
	push es;
	mov ax, 0xA000;
	mov es, ax;
	mov bx, [x];
	mov dx, [y];
	push bx;
	mov bx, dx;
	mov dh, dl;
	xor dl, dl;
	shl bx, 6;
	add dx, bx;
	pop bx;
	add bx, dx;
	mov di, bx;
	mov ax, es:[di];
	mov [col], al;
	pop es;
	pop ds;
  }
  return(col);
}